unit CustCard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, Grids, DBGrids, Mask, DBCtrls, DBTables,amdi;

type
  TCustomerCard = class(TForm)
    DataSource1: TDataSource;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Label3: TLabel;
    DBEdit4: TDBEdit;
    Label4: TLabel;
    DBEdit5: TDBEdit;
    Label5: TLabel;
    DBEdit6: TDBEdit;
    Label6: TLabel;
    DBEdit7: TDBEdit;
    DataSource2: TDataSource;
    Table2: TTable;
    DBGrid1: TDBGrid;
    Table2OrderNo: TFloatField;
    Table2CustNo: TFloatField;
    Table2SaleDate: TDateTimeField;
    Table2ShipDate: TDateTimeField;
    Table2EmpNo: TIntegerField;
    Table2ShipToContact: TStringField;
    Table2ShipToAddr1: TStringField;
    Table2ShipToAddr2: TStringField;
    Table2ShipToCity: TStringField;
    Table2ShipToState: TStringField;
    Table2ShipToZip: TStringField;
    Table2ShipToCountry: TStringField;
    Table2ShipToPhone: TStringField;
    Table2ShipVIA: TStringField;
    Table2PO: TStringField;
    Table2Terms: TStringField;
    Table2PaymentMethod: TStringField;
    Table2ItemsTotal: TCurrencyField;
    Table2TaxRate: TFloatField;
    Table2Freight: TCurrencyField;
    Table2AmountPaid: TCurrencyField;
    InsertButton: TButton;
    EditButton: TButton;
    DeleteButton: TButton;
    OkButton: TButton;
    CancelButton: TButton;
    Label7: TLabel;
    DBEdit8: TDBEdit;
    Label8: TLabel;
    DBEdit9: TDBEdit;
    Table3: TTable;
    Table2Employee: TStringField;
    Label9: TLabel;
    DBEdit10: TDBEdit;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure InsertButtonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CustomerCard: TCustomerCard;

procedure DoCustomerCard(Sender: TAMDIEngine;ParentForm:TForm);

implementation
{$R *.DFM}

uses ordrcard,custgrid;

procedure DoCustomerCard(Sender: TAMDIEngine;ParentForm:TForm);
begin
  with Sender do
  begin
    NewForm(TCustomerCard); {Create new form}
    with ActiveForm as TCustomerCard do {Set form's properties}
    begin
      DataSource1.Dataset:=(ParentForm as TCustomerGrid).Table1;
    end;
    ShowForm; {Show the form}
    while Not (Terminated or (ActiveState=AMDICloseState)) do
          { Form don't closed }
    begin
      case ActiveState of
      1,2: { Execute actions }
        begin
          ActiveState:=0;
          DoOrderCard(Sender,ActiveForm);
        end;
      else { Nothing, sleep }
        sleep(100);
      end;
    end;
    CloseForm; { Close the form}
  end;
end;

procedure TCustomerCard.OkButtonClick(Sender: TObject);
begin
  DataSource1.DataSet.Post; {Write changes}
  Close;
end;

procedure TCustomerCard.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TCustomerCard.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 if (DataSource1.DataSet.State=dsEdit) or (DataSource1.DataSet.State=dsInsert) then
   DataSource1.DataSet.Cancel; {Cancel changes}
end;

procedure TCustomerCard.InsertButtonClick(Sender: TObject);
begin
  Table2.Insert;
  Table2.FieldByName('CustNo').AsInteger:=
     DataSource1.DataSet.FieldByName('CustNo').AsInteger;
  Table2.FieldByName('TaxRate').AsFloat:=
     DataSource1.DataSet.FieldByName('TaxRate').AsFloat;
  AMDIEngines.States[Self]:=1;
end;

procedure TCustomerCard.EditButtonClick(Sender: TObject);
begin
  if not Table2.IsEmpty then
  begin
    Table2.Edit;
    AMDIEngines.States[Self]:=2;
  end;
end;

procedure TCustomerCard.DeleteButtonClick(Sender: TObject);
begin
  if not Table2.IsEmpty then
  begin
    if MessageDlg('Delete this record?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      Table2.Delete;
  end;
end;

end.
