unit OrdrCard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Db, DBTables, amdi;

type
  TOrderCard = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    DataSource1: TDataSource;
    Table2: TTable;
    Table2OrderNo: TFloatField;
    Table2CustNo: TFloatField;
    Table2Employee: TStringField;
    Table2SaleDate: TDateTimeField;
    Table2ShipDate: TDateTimeField;
    Table2AmountPaid: TCurrencyField;
    Table2TaxRate: TFloatField;
    Table2EmpNo: TIntegerField;
    Table2ShipToContact: TStringField;
    Table2ShipToAddr1: TStringField;
    Table2ShipToAddr2: TStringField;
    Table2ShipToCity: TStringField;
    Table2ShipToState: TStringField;
    Table2ShipToZip: TStringField;
    Table2ShipToCountry: TStringField;
    Table2ShipToPhone: TStringField;
    Table2ShipVIA: TStringField;
    Table2PO: TStringField;
    Table2Terms: TStringField;
    Table2PaymentMethod: TStringField;
    Table2ItemsTotal: TCurrencyField;
    Table2Freight: TCurrencyField;
    Table3: TTable;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Label3: TLabel;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    SelectEmplButton: TButton;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SelectEmplButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OrderCard: TOrderCard;

procedure DoOrderCard(Sender: TAMDIEngine;ParentForm:TForm);

implementation

{$R *.DFM}

uses emplgrid,custcard;

procedure DoOrderCard(Sender: TAMDIEngine;ParentForm:TForm);
begin
  with Sender do
  begin
    NewForm(TOrderCard);
    with ActiveForm as TOrderCard do
    begin
      DataSource1.Dataset:=(ParentForm as TCustomerCard).Table2;
    end;
    ShowForm;
    while Not (Terminated or (ActiveState=AMDICloseState)) do
    begin
      case ActiveState of
      1:
        begin
          ActiveState:=0;
          DoEmployeeGrid(Sender,ActiveForm);
        end;
      else
        sleep(100);
      end;
    end;
    CloseForm;
  end;
end;

procedure TOrderCard.OkButtonClick(Sender: TObject);
begin
  DataSource1.DataSet.Post;
  Close;
end;

procedure TOrderCard.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TOrderCard.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (DataSource1.DataSet.State=dsEdit) or (DataSource1.DataSet.State=dsInsert) then
    DataSource1.DataSet.Cancel;
end;

procedure TOrderCard.SelectEmplButtonClick(Sender: TObject);
begin
  AMDIEngines.States[Self]:=1;
end;

end.
