object CustomerGrid: TCustomerGrid
  Left = 244
  Top = 221
  Width = 404
  Height = 301
  Caption = 'Customers'
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'MS Sans Serif'
  Font.Style = []
  OldCreateOrder = False
  PixelsPerInch = 96
  TextHeight = 13
  object Panel1: TPanel
    Left = 0
    Top = 233
    Width = 396
    Height = 41
    Align = alBottom
    TabOrder = 0
    object InsertButton: TButton
      Left = 8
      Top = 8
      Width = 49
      Height = 25
      Caption = 'New'
      TabOrder = 0
      OnClick = InsertButtonClick
    end
    object EditButton: TButton
      Left = 64
      Top = 8
      Width = 49
      Height = 25
      Caption = 'Edit'
      TabOrder = 1
      OnClick = EditButtonClick
    end
    object DeleteButton: TButton
      Left = 120
      Top = 8
      Width = 49
      Height = 25
      Caption = 'Delete'
      TabOrder = 2
      OnClick = DeleteButtonClick
    end
    object SelectButton: TButton
      Left = 176
      Top = 8
      Width = 49
      Height = 25
      Caption = 'Select'
      TabOrder = 3
      Visible = False
      OnClick = SelectButtonClick
    end
    object CloseButton: TButton
      Left = 232
      Top = 8
      Width = 49
      Height = 25
      Caption = 'Close'
      TabOrder = 4
      OnClick = CloseButtonClick
    end
  end
  object Panel2: TPanel
    Left = 0
    Top = 0
    Width = 396
    Height = 233
    Align = alClient
    BevelInner = bvSpace
    TabOrder = 1
    object DBGrid1: TDBGrid
      Left = 2
      Top = 2
      Width = 392
      Height = 229
      Align = alClient
      DataSource = DataSource1
      Options = [dgTitles, dgIndicator, dgColumnResize, dgColLines, dgRowLines, dgTabs, dgRowSelect, dgConfirmDelete, dgCancelOnExit]
      TabOrder = 0
      TitleFont.Charset = DEFAULT_CHARSET
      TitleFont.Color = clWindowText
      TitleFont.Height = -11
      TitleFont.Name = 'MS Sans Serif'
      TitleFont.Style = []
      OnDblClick = EditButtonClick
    end
  end
  object DataSource1: TDataSource
    DataSet = Table1
    Left = 48
    Top = 120
  end
  object Table1: TTable
    Active = True
    DatabaseName = 'DBDEMOS'
    IndexName = 'ByCompany'
    TableName = 'CUSTOMER.DB'
    Left = 104
    Top = 144
    object Table1CustNo: TFloatField
      Alignment = taLeftJustify
      CustomConstraint = 'CustNo IS NOT NULL'
      ConstraintErrorMessage = 'CustNo cannot be blank'
      FieldName = 'CustNo'
      Visible = False
      DisplayFormat = 'CN 0000'
      MaxValue = 9999
      MinValue = 1000
    end
    object Table1Company: TStringField
      CustomConstraint = 'X IS NOT NULL'
      ConstraintErrorMessage = 'Company Field has to have a value'
      DisplayWidth = 36
      FieldName = 'Company'
      Size = 30
    end
    object Table1Addr1: TStringField
      FieldName = 'Addr1'
      Visible = False
      Size = 30
    end
    object Table1Addr2: TStringField
      FieldName = 'Addr2'
      Visible = False
      Size = 30
    end
    object Table1City: TStringField
      DisplayWidth = 18
      FieldName = 'City'
      Size = 15
    end
    object Table1State: TStringField
      DisplayWidth = 11
      FieldName = 'State'
    end
    object Table1Zip: TStringField
      FieldName = 'Zip'
      Visible = False
      Size = 10
    end
    object Table1Country: TStringField
      DisplayWidth = 24
      FieldName = 'Country'
    end
    object Table1Phone: TStringField
      DisplayWidth = 18
      FieldName = 'Phone'
      Size = 15
    end
    object Table1FAX: TStringField
      DisplayWidth = 18
      FieldName = 'FAX'
      Size = 15
    end
    object Table1TaxRate: TFloatField
      DisplayWidth = 12
      FieldName = 'TaxRate'
      DisplayFormat = '0.00%'
      MaxValue = 100
    end
    object Table1Contact: TStringField
      FieldName = 'Contact'
      Visible = False
    end
    object Table1LastInvoiceDate: TDateTimeField
      FieldName = 'LastInvoiceDate'
      Visible = False
    end
  end
end
