unit EmplCard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, Mask, DBCtrls, amdi;

type
  TEmployeeCard = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    DataSource1: TDataSource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EmployeeCard: TEmployeeCard;

procedure DoEmployeeCard(Sender: TAMDIEngine;ParentForm:TForm);

implementation

{$R *.DFM}

uses emplgrid;

procedure DoEmployeeCard(Sender: TAMDIEngine;ParentForm:TForm);
begin
  with Sender do
  begin
    NewForm(TEmployeeCard);
    with ActiveForm as TEmployeeCard do
    begin
      DataSource1.Dataset:=(ParentForm as TEmployeeGrid).Table1;
    end;
    ShowForm;
    while Not (Terminated or (ActiveState=AMDICloseState)) do
    begin
      sleep(100);
    end;
    CloseForm;
  end;
end;

procedure TEmployeeCard.OkButtonClick(Sender: TObject);
begin
  DataSource1.DataSet.Post;
  Close;
end;

procedure TEmployeeCard.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TEmployeeCard.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (DataSource1.DataSet.State=dsEdit) or (DataSource1.DataSet.State=dsInsert) then
    DataSource1.DataSet.Cancel;
end;

end.
